(ql:quickload :ritherdon-archive)

(defpackage ritherdon-archive.app
  (:use :cl)
  (:import-from :lack.builder
                :builder)
  (:import-from :ppcre
                :scan
                :regex-replace)
  (:import-from :ritherdon-archive.web
                :*web*)
  (:import-from :ritherdon-archive.config
                :config
                :productionp
                :*static-directory*))
(in-package :ritherdon-archive.app)

(funcall clack-errors:*clack-error-middleware*
	 ;; The funcall line above is added as part of the
	 ;; clack-errors set-up. Usually, the '(builder' line is the
	 ;; start of this block.
	 (builder
	  (:static
	   :path (lambda (path)
		   (if (ppcre:scan "^(?:/images/|/css/|/js/|/robots\\.txt$|/favicon\\.ico$)" path)
		       path
		       nil))
	   :root *static-directory*)
	  (if (productionp)
	      nil
	      :accesslog)
	  (if (getf (config) :error-log)
	      `(:backtrace
		:output ,(getf (config) :error-log))
	      nil)
	  :session
	  (if (productionp)
	      nil
	      (lambda (app)
		(lambda (env)
		  (let ((datafly:*trace-sql* t))
		    (funcall app env)))))
	  *web*)
	 :debug (if (ritherdon-archive.config:productionp)
		    nil
		    t)) ; Added as part of clack-error-middleware.
