;;;
;;; define helper packages,
;;; the models,
;;; the web,
;;; and the base package that relies on all of them.
;;;

(defpackage ritherdon-archive/utils
  (:use :cl
        :log4cl)
  (:export #:format-date
           #:i18n-load
           #:_
           #:parse-iso-date)
  (:documentation "Utilities that do not depend on models."))

(defpackage ritherdon-archive/models
  (:use :cl)
  (:export :connect
           :make-product
           :select-products
           :find-by))

(defpackage ritherdon-archive/web
  (:use :cl)
  (:import-from :easy-routes
                :defroute)
  (:export :start-app
           :stop-app)
  (:local-nicknames (#:a #:alexandria)
                    (#:models #:ritherdon-archive/models)
                    (#:utils #:ritherdon-archive/utils)))

(defpackage ritherdon-archive
  (:use :cl
        :log4cl)
  (:export :main :run)
  (:local-nicknames (#:a #:alexandria)
                    (#:models #:ritherdon-archive/models)
                    (#:web #:ritherdon-archive/web)
                    (#:utils #:ritherdon-archive/utils)))
